#include <GUIConstantsEx.au3>
#include <ComboConstants.au3>
#include <StaticConstants.au3>
#include <ProgressConstants.au3>
#include <SysInfo_UDF.au3>

Opt("GUIOnEventMode", 1)
Opt("TrayOnEventMode", 1)
Opt("TrayMenuMode", 1)

TraySetOnEvent(-7, "_ShowGUI_Proc")

Global $iWrite_Ini 				= False
Global $iShowAdditionalInfo 	= False

Global $sConfigFile	= StringTrimRight(@ScriptFullPath, 3) & "ini"

$MostUsed 			= IniRead($sConfigFile, "RAM", "Most", "0")
$LeastUsed 			= IniRead($sConfigFile, "RAM", "Least", "100")
$MostUsedPF 		= IniRead($sConfigFile, "PF", "Most", "0")
$LeastUsedPF 		= IniRead($sConfigFile, "PF", "Least", "100")

$aMemory_Data 		= MemGetStats()
$aDrives_Data 		= DriveGetDrive("Fixed")

Global $PrgBar[$aDrives_Data[0]+1]
Global $FreePercentLbl[$aDrives_Data[0]+1]
Global $FreeSpaceLbl[$aDrives_Data[0]+1]
Global $TotalSpaceLbl[$aDrives_Data[0]+1]

Global $iLblTop 	= 40
Global $iPrgTop 	= 50

$hMain_GUI			= GUICreate("MemStats By AutoItKing, Free Resources By Rasim - Modified/Merged by G.Sandler", 620, 360)
$hMain_Tab 			= GUICtrlCreateTab(2, 2, 616, 356)

GUICtrlCreateTabItem("Drives")

For $i = 1 To $aDrives_Data[0]
	FileChangeDir($aDrives_Data[$i] & "\")
	
	$PrgBar[$i] = GUICtrlCreateProgress(150, $iPrgTop, 200, 17, $PBS_SMOOTH)
    GUICtrlSetColor(-1, 0xFF0000)
    GUICtrlSetBkColor(-1, 0x00F200)
    
    DllCall("UxTheme.dll", "int", "SetWindowTheme", "hwnd", GUICtrlGetHandle($PrgBar[$i]), "wstr", "", "wstr", "")
    
	$sIconFile = "Shell32.dll"
	$sIconIndex = 8
	
	$aIcon = StringSplit(IniRead($aDrives_Data[$i] & "\Autorun.inf", "autorun", "Icon", ""), ",")
	
	If FileExists($aIcon[1]) Then $sIconFile = $aIcon[1]
	If $aIcon[0] > 1 Then $sIconIndex = $aIcon[$aIcon[0]]
	
	GUICtrlCreateIcon($sIconFile, $sIconIndex, 10, $iLblTop + 3, 24, 24)
	
    GUICtrlCreateLabel("(" & StringUpper($aDrives_Data[$i]) & "\) " & DriveGetLabel($aDrives_Data[$i]), _
		40, $iLblTop + 12, -1, 15, $SS_NOPREFIX)
    GUICtrlSetFont(-1, 7, 400)
    
    GUICtrlCreateLabel("Free space is: ", 235, $iLblTop - 10, 110, 15)
    GUICtrlSetFont(-1, Default, 800)
    
    $FreePercentLbl[$i] = GUICtrlCreateLabel("", 315, $iLblTop - 10, 50, 15)
    GUICtrlSetColor(-1, 0x009300)
    
    GUICtrlCreateLabel("Free space: ", 370, $iLblTop, 60, 15)
    
    $FreeSpaceLbl[$i] = GUICtrlCreateLabel("", 430, $iLblTop, 50, 15)
    GUICtrlSetFont(-1, Default, 800)
    GUICtrlSetColor(-1, 0x009300)
    
    GUICtrlCreateLabel("Total size: ", 370, $iLblTop + 20, 55, 15)
    
    $TotalSpaceLbl[$i] = GUICtrlCreateLabel(Round(DriveSpaceTotal($aDrives_Data[$i]) / 1024, 2) & " GB", 430, $iLblTop + 20, 50, 15)
    GUICtrlSetFont(-1, Default, 800)
    GUICtrlSetColor(-1, 0x009300)
    
    $iLblTop += 70
    $iPrgTop += 70
Next

GUICtrlCreateTabItem("Memory")

$Specs_Group 		= GUICtrlCreateGroup("Specs", 10, 30, 250, 200)
$TR_Label 			= GUICtrlCreateLabel("Total RAM: " & Round($aMemory_Data[1]/1024, 1) & " MB", 25, 50, 230, 15)
$TCS_Label 			= GUICtrlCreateLabel("Total C: Space: " & Round(DriveSpaceTotal("C:")/1024, 1) & " GB", 25, 80, 230, 15)
$AvC_Label 			= GUICtrlCreateLabel("Available C: Space: " & Round(DriveSpaceFree("C:")/1024, 1) & " GB", 25, 110, 230, 15)
$FS_Label 			= GUICtrlCreateLabel("File System: " & DriveGetFileSystem("C:"), 25, 140, 230, 15)
$TPF_Label 			= GUICtrlCreateLabel("Total PF: " & Round($aMemory_Data[3]/1024, 1) & " MB", 25, 170, 230, 15)

$RAMUsage_Group 	= GUICtrlCreateGroup("RAM Usage", 270, 30, 340, 150)
$Progress1 			= GUICtrlCreateProgress(290, 50, 300, 20)

$RamMBInUse_Label 	= GUICtrlCreateLabel(Round(($aMemory_Data[1]-$aMemory_Data[2])/1024, 1) & " MB in use", 310, 75, 100, 17)
$RamMBAvail_Label 	= GUICtrlCreateLabel(Round($aMemory_Data[2]/1024, 1) & " MB available", 310, 95, 100, 17)
$Percent 			= GUICtrlCreateLabel($aMemory_Data[0] & "% Percent Used", 310, 115, 100, 17)

$LeastUsed_Label 	= GUICtrlCreateLabel("Least used: " & $LeastUsed & "%", 310, 140, 100, 17)
$MostUsed_Label 	= GUICtrlCreateLabel("Most used: " & $MostUsed & "%", 310, 155, 100, 17)

$PFUsage_Group 		= GUICtrlCreateGroup("Page File Usage", 270, 185, 340, 155)
$Progress2 			= GUICtrlCreateProgress(290, 205, 300, 20)

$PFInUse_Label 		= GUICtrlCreateLabel(Round(($aMemory_Data[3]-$aMemory_Data[4])/1024, 1) & " MB in use", 310, 230, 100, 17)
$PFAvail_Label 		= GUICtrlCreateLabel(Round($aMemory_Data[4]/1024, 1) & " MB available", 310, 250, 100, 17)
$PFPercent_Label 	= GUICtrlCreateLabel(Round(($aMemory_Data[3]-$aMemory_Data[4])/$aMemory_Data[3], 0) & _
	"% Percent Used", 310, 270, 100, 17)

$LeastPF_Label 		= GUICtrlCreateLabel("Least used: " & $LeastUsedPF & "%", 310, 300, 100, 17)
$MostPF_Label 		= GUICtrlCreateLabel("Most used: " & $MostUsedPF & "%", 310, 315, 100, 17)

$ReduceMem_Button 	= GUICtrlCreateButton("Reduce Memory Usage", 10, 240, 250, 30)
GUICtrlSetOnEvent(-1, "_Main_Events")

$Optimize_Label 	= GUICtrlCreateLabel("", 10, 280, 250, 30)

If $iShowAdditionalInfo Then Set_AdditionalInfo_Proc()

GUICtrlCreateTabItem("")

GUISetOnEvent($GUI_EVENT_CLOSE, 	"_Main_Events")
GUISetOnEvent($GUI_EVENT_MINIMIZE, 	"_Main_Events")

_ShowGUI_Proc()
_SetTrayToolTipData_Proc()

While 1
	Switch GUICtrlRead($hMain_Tab)
		Case 0
			_SetDrivesAndMemoryLabels_Proc(1) ;Only Drives
		Case 1
			_SetDrivesAndMemoryLabels_Proc(2) ;Only Memory
	EndSwitch
	
	Sleep(100)
WEnd

Func _Main_Events()
	Switch @GUI_CtrlId
		Case $GUI_EVENT_CLOSE
			Exit
		Case $GUI_EVENT_MINIMIZE
			GUISetState(@SW_HIDE)
			Execute('AdlibEnable("_SetTrayToolTipData_Proc", 1000)')
			If @error Then Execute('AdlibRegister("_SetTrayToolTipData_Proc", 1000)')
		Case $ReduceMem_Button
			Local $aProcesses = ProcessList()
			If @error Then Return MsgBox(48, "Error", "Could not enumerate processes.")
			
			GUISetState(@SW_DISABLE)
			
			For $i = 1 To $aProcesses[0][0]
				$iCurrent_Proc = $aProcesses[$i][1]
				
				GUICtrlSetData($Optimize_Label, "Optimizing RAM: " & $aProcesses[$i][0])
				_ReduceMemory($iCurrent_Proc)
				
				If Mod($i, 2) Then _SetDrivesAndMemoryLabels_Proc(2) ;Only Memory
				
				Sleep(50)
			Next
			
			GUICtrlSetData($Optimize_Label, "")
			GUISetState(@SW_ENABLE)
	EndSwitch
EndFunc

Func _SetTrayToolTipData_Proc()
	$aMemory_Data = MemGetStats()
	
	TraySetToolTip(StringFormat( _
		"%s Free Space: %s\nRam Usage: %d MB in use\nPage File Usage: %d MB in use", _
		@HomeDrive & "\", _
		_GetDisplaySize(Round(DriveSpaceFree(@HomeDrive) * 1024 * 1024)), _
		Round(($aMemory_Data[1]-$aMemory_Data[2])/1024, 1), _
		Round(($aMemory_Data[3]-$aMemory_Data[4])/1024, 1)))
EndFunc

;$iFlag = 1 - Set only Drives
;$iFlag = 2 - Set only Memory
;$iFlag = 3 - Set both
Func _SetDrivesAndMemoryLabels_Proc($iFlag=3)
	Local $iTotal, $iFree, $iPercFree, $iUsed
	$aMemory_Data = MemGetStats()
	
	If $iFlag = 1 Or $iFlag = 3 Then
		For $i = 1 To $aDrives_Data[0]
			$iTotal = Round(DriveSpaceTotal($aDrives_Data[$i]) * 1024 * 1024)
			$iFree = Round(DriveSpaceFree($aDrives_Data[$i]) * 1024 * 1024)
			$iPercFree = Round(($iFree / $iTotal) * 100, 2)
			$iUsed = Round(100 - $iPercFree, 2)
			
			_GUICtrlSetData($PrgBar[$i], $iUsed)
			_GUICtrlSetData($FreePercentLbl[$i], $iPercFree & "%")
			_GUICtrlSetData($FreeSpaceLbl[$i], _GetDisplaySize($iFree))
		Next
		
		If $iFlag = 1 Then Return
	EndIf
	
	_GUICtrlSetData($Percent, $aMemory_Data[0] & "% Percent Used")
	_GUICtrlSetData($RamMBInUse_Label, Round(($aMemory_Data[1]-$aMemory_Data[2])/1024, 1) & " MB in use")
	_GUICtrlSetData($RamMBAvail_Label, Round($aMemory_Data[2]/1024, 1) & " MB available")
	
	GUICtrlSetData($Progress1, $aMemory_Data[0])
	
	_GUICtrlSetData($PFPercent_Label, Round((($aMemory_Data[3]-$aMemory_Data[4])/$aMemory_Data[3])*100, 0) & "% Percent Used")
	_GUICtrlSetData($PFInUse_Label, Round(($aMemory_Data[3]-$aMemory_Data[4])/1024, 1) & " MB in use")
	_GUICtrlSetData($PFAvail_Label, Round($aMemory_Data[4]/1024, 1) & " MB available")
	
	GUICtrlSetData($Progress2, Round((($aMemory_Data[3]-$aMemory_Data[4])/$aMemory_Data[3])*100, 0))
	
	If $aMemory_Data[0] > $MostUsed Then
		$MostUsed = $aMemory_Data[0]
		
		_GUICtrlSetData($MostUsed_Label, "Most used: " & $MostUsed & "%")
		_IniWrite($sConfigFile, "RAM", "Most", $MostUsed)
	EndIf
	
	If $aMemory_Data[0] < $LeastUsed Then
		$LeastUsed = $aMemory_Data[0]
		
		_GUICtrlSetData($LeastUsed_Label, "Least used: " & $LeastUsed & "%")
		_IniWrite($sConfigFile, "RAM", "Least", $LeastUsed)
	EndIf
	
	If Round((($aMemory_Data[3]-$aMemory_Data[4])/$aMemory_Data[3])*100, 0) > $MostUsedPF Then
		$MostUsedPF = Round((($aMemory_Data[3]-$aMemory_Data[4])/$aMemory_Data[3])*100, 0)
		
		_GUICtrlSetData($MostPF_Label, "Most used: " & $MostUsedPF & "%")
		_IniWrite($sConfigFile, "PF", "Most", $MostUsedPF)
	EndIf
	
	If Round((($aMemory_Data[3]-$aMemory_Data[4])/$aMemory_Data[3])*100, 0) < $LeastUsedPF Then
		$LeastUsedPF = Round((($aMemory_Data[3]-$aMemory_Data[4])/$aMemory_Data[3])*100, 0)
		
		_GUICtrlSetData($LeastPF_Label, "Least used: " & $LeastUsedPF & "%")
		_IniWrite($sConfigFile, "PF", "Least", $LeastUsedPF)
	EndIf
	
	_SetTrayToolTipData_Proc()
EndFunc

Func Set_AdditionalInfo_Proc()
	Local $aSoundCards 		= _ComputerGetSoundCards()
	Local $aVideoCards 		= _ComputerGetVideoCards()
	Local $aNetworkCards 	= _ComputerGetNetworkCards()
	Local $aSoftwares 		= _ComputerGetSoftware()
	
	GUICtrlCreateTabItem("Additional Info")
	
	GUICtrlCreateLabel("Sound Cards:", 20, 32, 100)
	GUICtrlSetFont(-1, 9, 800)
	$SoundCards_Combo = GUICtrlCreateCombo("", 140, 30, 460, 20, BitOr($GUI_SS_DEFAULT_COMBO, $CBS_DROPDOWNLIST))
	
	For $i = 1 To UBound($aSoundCards)-1
		GUICtrlSetData($SoundCards_Combo, $aSoundCards[$i][0], $aSoundCards[$i][0])
	Next
	
	GUICtrlCreateLabel("Video Cards:", 20, 62, 100)
	GUICtrlSetFont(-1, 9, 800)
	$VideoCards_Combo = GUICtrlCreateCombo("", 140, 60, 460, 20, BitOr($GUI_SS_DEFAULT_COMBO, $CBS_DROPDOWNLIST))
	
	For $i = 1 To UBound($aVideoCards)-1
		GUICtrlSetData($VideoCards_Combo, $aVideoCards[$i][0], $aVideoCards[$i][0])
	Next
	
	GUICtrlCreateLabel("Network Cards:", 20, 92, 100)
	GUICtrlSetFont(-1, 9, 800)
	$NetworkCards_Combo = GUICtrlCreateCombo("", 140, 90, 460, 20, BitOr($GUI_SS_DEFAULT_COMBO, $CBS_DROPDOWNLIST))
	
	For $i = 1 To UBound($aNetworkCards)-1
		GUICtrlSetData($NetworkCards_Combo, $aNetworkCards[$i][0], $aNetworkCards[$i][0])
	Next
	
	GUICtrlCreateLabel("Installed Softwares:", 20, 130, 120, 17)
	GUICtrlSetFont(-1, 9, 800)
	$InstalledSoft_ListView = GUICtrlCreateListView("Display Name|Display Version|Publisher|UninstallString", 20, 150, 580, 180)

	For $i = 1 To UBound($aSoftwares)-1
		If $aSoftwares[$i][0] = "" Then ContinueLoop
		
		GUICtrlCreateListViewItem($aSoftwares[$i][0] & "|" & $aSoftwares[$i][1] & "|" & _
			$aSoftwares[$i][2] & "|" & $aSoftwares[$i][3], $InstalledSoft_ListView)
	Next
EndFunc

Func _GUICtrlSetData($iCtrlID, $sData, $sDefault="")
	If GUICtrlRead($iCtrlID) <> $sData Then GUICtrlSetData($iCtrlID, $sData, $sDefault)
EndFunc

Func _IniWrite($sFileName, $sSection, $sKey, $sDefault="")
	If $iWrite_Ini Then IniWrite($sFileName, $sSection, $sKey, $sDefault)
EndFunc

Func _GetDisplaySize($iSize, $iPlaces = 1)
	Local $aBytes[5] = [' Bytes', ' KB', ' MB', ' GB', ' TB']
	
	For $i = 4 To 1 Step -1
		If $iSize >= 1024 ^ $i Then
			Return Round($iSize / 1024 ^ $i, $iPlaces) & $aBytes[$i]
		EndIf
	Next
	
	Return Round($iSize, $iPlaces) & ' Bytes'
EndFunc

Func _ReduceMemory($i_PID = -1)
	If $i_PID <> - 1 Then
		Local $ai_Handle = DllCall("kernel32.dll", 'int', 'OpenProcess', 'int', 0x1f0fff, 'int', False, 'int', $i_PID)
		Local $ai_Return = DllCall("psapi.dll", 'int', 'EmptyWorkingSet', 'long', $ai_Handle[0])
		DllCall('kernel32.dll', 'int', 'CloseHandle', 'int', $ai_Handle[0])
	Else
		Local $ai_Return = DllCall("psapi.dll", 'int', 'EmptyWorkingSet', 'long', -1)
	EndIf
	
	Return $ai_Return[0]
EndFunc

Func _ShowGUI_Proc()
	GUISetState(@SW_SHOW)
	Execute("AdlibDisable()")
	If @error Then Execute('AdlibUnRegister("_SetTrayToolTipData_Proc")')
EndFunc
